# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [1.0.0]
### Added
- `to_xml()` method in `OsmChange`.
- `upload()` method in `changeset` `endpoint` has new optional arguments.
- Test for `to_xml()` method in `OsmChange`.
- `# pragma: no cover` for unexpected api errors (Those that are not in the specification on the wiki).

### Changed
- Private `_to_xml()` method in `OsmChange` is now static.

## [0.4.2]

### Changed
- Order of elements in xml generated by `Way._to_xml()`. First tags, then nodes.

### Fixed
- `Relation._to_xml()` was returning an xml without osm tags.
- Deleted disused variable in `Node._to_xml()`.
- Fixed incorrect relation parsing of data recived by `full` endpoint.

## [0.4.1]
### Changed
- Updated `requests` from `2.28.1` to `2.31.0`.

## [0.4.0]
### Added
- `to_dict()` method and `from_dict()` class method to `Note`.  
- `to_dict()` method and `from_dict()` class method to `Comment`.
- `to_dict()` method and `from_dict()` class method to `User`.
- Documentation about `Meta` and `Action` class.
- Assert error (with information to report it on github) when api returns an error code not described on the wiki.
- `to_dict()` method and `from_dict()` class method to `(relation) Member`.

### Fixed
- `Note` can now be imported from package.
- `Comment` can now be imported from package.
- `User` can now be imported from package.
- `Member` can now be imported from package.
- Pdoc command in `README.md`.
- `Relation.to_dict()` method now recursively serialises members.
- `Way.to_dict()` method now recursively serialises nodes.

### Changed
- Changed imports in `Relation.py` to use importing through a module rather than directly from a file.
- Added `sample_dataclasses.py` file in tests fixtures to reduce code duplication.
- Changed function name and deleted unnecessary argument in `append_elements_to_master_element()` nested inside private method `_to_xml()` in `OsmChange`.

## [0.3.0] - 2023-03-14

### Added
- `to_dict()` method and `from_dict()` class method to Changeset. [#7](https://github.com/docentYT/osm_easy_api/issues/7)
- Ability to set user_agent in `Diff` and `Api` class. [#5](https://github.com/docentYT/osm_easy_api/issues/5)
- `osm_object_primitive` `from_dict()` class method now raises `ValueError` if the `type` key is not found.

### Changed
- `Changeset` is now exported from data_classes module.
- More tests.

## [0.2.0] - 2023-03-07

### Added
- `to_dict()` method and `from_dict()` class method to `osm_object_primitive`. (An object that is inherited by a `Node`, `Way`, `Relation`). [#3](https://github.com/docentYT/osm_easy_api/issues/3)
- Support for historical anonymous edits and edits made by deleted accounts. [#4](https://github.com/docentYT/osm_easy_api/issues/4)

## [0.1.4] - 2023-03-05

### Fixed
- Improvement of utils.join_url() function.
- Spelling errors corrected [@matkoniecz](https://github.com/matkoniecz)

## [0.1.3] - 2023-03-03

### Fixed

- Fixed the non-setting of the "visible" attribute.

## [0.1.2] - 2023-03-03

### Fixed

- Fixed return type of generator in Diff.get() method.

## [0.1.1] - 2023-03-03

### Added

- License

## [0.1.0] - 2023-03-03

### Added

- Initial import